From 3b535d4005b0486d918913b3128554e56dd154a5 Mon Sep 17 00:00:00 2001
From: DreamMaoMao <2523610504@qq.com>
Date: Fri, 19 Jun 2026 13:16:57 +0800
Subject: [PATCH 08/16] mix: add window share and fix 
 xcursor,text-input,ext-workspace

---
 meson.build                             |   5 +-
 src/ext-protocol/ext-workspace.h        | 108 ++-
 src/ext-protocol/text-input.h           |  22 +-
 src/ext-protocol/wlr_ext_workspace_v1.c | 997 ------------------------
 src/ext-protocol/wlr_ext_workspace_v1.h | 106 ---
 src/fetch/monitor.h                     |   9 +
 src/mango.c                             |  86 +-
 7 files changed, 163 insertions(+), 1170 deletions(-)
 delete mode 100644 src/ext-protocol/wlr_ext_workspace_v1.c
 delete mode 100644 src/ext-protocol/wlr_ext_workspace_v1.h

diff --git a/meson.build b/meson.build
index 478ef0e6b..f6f6d6f91 100644
--- a/meson.build
+++ b/meson.build
@@ -33,12 +33,12 @@ libm = cc.find_library('m')
 xcb = dependency('xcb', required : get_option('xwayland'))
 xlibs = dependency('xcb-icccm', required : get_option('xwayland'))
 wayland_server_dep = dependency('wayland-server',version: '>=1.23.1')
-wlroots_dep = dependency('wlroots-0.19',version: '>=0.19.0')
+wlroots_dep = dependency('wlroots-0.20',version: '>=0.20.0')
 xkbcommon_dep = dependency('xkbcommon')
 libinput_dep = dependency('libinput',version: '>=1.27.1')
 libwayland_client_dep = dependency('wayland-client')
 pcre2_dep = dependency('libpcre2-8')
-libscenefx_dep = dependency('scenefx-0.4',version: '>=0.4.1')
+libscenefx_dep = dependency('scenefx-0.5',version: '>=0.5.0')
 
 
 # 获取版本信息
@@ -97,7 +97,6 @@ endif
 executable('mango',
   'src/mango.c',
   'src/common/util.c',
-  'src/ext-protocol/wlr_ext_workspace_v1.c',
   wayland_sources,
   dependencies : [
     libm,
diff --git a/src/ext-protocol/ext-workspace.h b/src/ext-protocol/ext-workspace.h
index 28aaeeeb7..82b7ef1f2 100644
--- a/src/ext-protocol/ext-workspace.h
+++ b/src/ext-protocol/ext-workspace.h
@@ -1,4 +1,4 @@
-#include "wlr_ext_workspace_v1.h"
+#include <wlr/types/wlr_ext_workspace_v1.h>
 
 #define EXT_WORKSPACE_ENABLE_CAPS                                              \
 	EXT_WORKSPACE_HANDLE_V1_WORKSPACE_CAPABILITIES_ACTIVATE |                  \
@@ -7,20 +7,20 @@
 typedef struct Monitor Monitor;
 
 struct workspace {
-	struct wl_list link; // Link in global workspaces list
-	uint32_t tag;		 // Numeric identifier (1-9, 0=overview)
-	Monitor *m;			 // Associated monitor
-	struct wlr_ext_workspace_handle_v1 *ext_workspace; // Protocol object
-	/* Event listeners */
-	struct wl_listener activate;
-	struct wl_listener deactivate;
-	struct wl_listener assign;
-	struct wl_listener remove;
+	struct wl_list link;
+	uint32_t tag;
+	Monitor *m;
+	struct wlr_ext_workspace_handle_v1 *ext_workspace;
+	struct wl_listener commit;
 };
 
 struct wlr_ext_workspace_manager_v1 *ext_manager;
 struct wl_list workspaces;
 
+static void handle_ext_commit(struct wl_listener *listener, void *data);
+static struct wl_listener ext_manager_commit_listener = {.notify =
+															 handle_ext_commit};
+
 void goto_workspace(struct workspace *target) {
 	uint32_t tag;
 	tag = 1 << (target->tag - 1);
@@ -43,30 +43,60 @@ void toggle_workspace(struct workspace *target) {
 	}
 }
 
-static void handle_ext_workspace_activate(struct wl_listener *listener,
-										  void *data) {
-	struct workspace *workspace =
-		wl_container_of(listener, workspace, activate);
+static void handle_ext_commit(struct wl_listener *listener, void *data) {
+	struct wlr_ext_workspace_v1_commit_event *event = data;
+	struct wlr_ext_workspace_v1_request *request;
 
-	if (workspace->m->isoverview) {
-		return;
-	}
+	wl_list_for_each(request, event->requests, link) {
+		switch (request->type) {
+		case WLR_EXT_WORKSPACE_V1_REQUEST_ACTIVATE: {
+			if (!request->activate.workspace) {
+				break;
+			}
 
-	goto_workspace(workspace);
-	wlr_log(WLR_INFO, "ext activating workspace %d", workspace->tag);
-}
+			struct workspace *workspace = NULL;
+			struct workspace *w;
+			wl_list_for_each(w, &workspaces, link) {
+				if (w->ext_workspace == request->activate.workspace) {
+					workspace = w;
+					break;
+				}
+			}
 
-static void handle_ext_workspace_deactivate(struct wl_listener *listener,
-											void *data) {
-	struct workspace *workspace =
-		wl_container_of(listener, workspace, deactivate);
+			if (!workspace || workspace->m->isoverview) {
+				break;
+			}
 
-	if (workspace->m->isoverview) {
-		return;
-	}
+			goto_workspace(workspace);
+			wlr_log(WLR_INFO, "ext activating workspace %d", workspace->tag);
+			break;
+		}
+		case WLR_EXT_WORKSPACE_V1_REQUEST_DEACTIVATE: {
+			if (!request->deactivate.workspace) {
+				break;
+			}
 
-	toggle_workspace(workspace);
-	wlr_log(WLR_INFO, "ext deactivating workspace %d", workspace->tag);
+			struct workspace *workspace = NULL;
+			struct workspace *w;
+			wl_list_for_each(w, &workspaces, link) {
+				if (w->ext_workspace == request->deactivate.workspace) {
+					workspace = w;
+					break;
+				}
+			}
+
+			if (!workspace || workspace->m->isoverview) {
+				break;
+			}
+
+			toggle_workspace(workspace);
+			wlr_log(WLR_INFO, "ext deactivating workspace %d", workspace->tag);
+			break;
+		}
+		default:
+			break;
+		}
+	}
 }
 
 static const char *get_name_from_tag(uint32_t tag) {
@@ -76,8 +106,6 @@ static const char *get_name_from_tag(uint32_t tag) {
 }
 
 void destroy_workspace(struct workspace *workspace) {
-	wl_list_remove(&workspace->activate.link);
-	wl_list_remove(&workspace->deactivate.link);
 	wlr_ext_workspace_handle_v1_destroy(workspace->ext_workspace);
 	wl_list_remove(&workspace->link);
 	free(workspace);
@@ -112,17 +140,12 @@ static void add_workspace_by_tag(int32_t tag, Monitor *m) {
 	workspace->m = m;
 	workspace->ext_workspace = wlr_ext_workspace_handle_v1_create(
 		ext_manager, name, EXT_WORKSPACE_ENABLE_CAPS);
+
+	workspace->ext_workspace->data = workspace;
+
 	wlr_ext_workspace_handle_v1_set_group(workspace->ext_workspace,
 										  m->ext_group);
 	wlr_ext_workspace_handle_v1_set_name(workspace->ext_workspace, name);
-
-	workspace->activate.notify = handle_ext_workspace_activate;
-	wl_signal_add(&workspace->ext_workspace->events.activate,
-				  &workspace->activate);
-
-	workspace->deactivate.notify = handle_ext_workspace_deactivate;
-	wl_signal_add(&workspace->ext_workspace->events.deactivate,
-				  &workspace->deactivate);
 }
 
 void dwl_ext_workspace_printstatus(Monitor *m) {
@@ -165,10 +188,10 @@ void refresh_monitors_workspaces_status(Monitor *m) {
 	int32_t i;
 
 	if (m->isoverview) {
+		add_workspace_by_tag(0, m);
 		for (i = 1; i <= LENGTH(tags); i++) {
 			remove_workspace_by_tag(i, m);
 		}
-		add_workspace_by_tag(0, m);
 	} else {
 		remove_workspace_by_tag(0, m);
 		for (i = 1; i <= LENGTH(tags); i++) {
@@ -180,8 +203,9 @@ void refresh_monitors_workspaces_status(Monitor *m) {
 }
 
 void workspaces_init() {
-	/* Create the global workspace manager with activation capability */
 	ext_manager = wlr_ext_workspace_manager_v1_create(dpy, 1);
-	/* Initialize the global workspaces list */
+
 	wl_list_init(&workspaces);
+
+	wl_signal_add(&ext_manager->events.commit, &ext_manager_commit_listener);
 }
\ No newline at end of file
diff --git a/src/ext-protocol/text-input.h b/src/ext-protocol/text-input.h
index dbd97e11f..7b4e1a1fd 100644
--- a/src/ext-protocol/text-input.h
+++ b/src/ext-protocol/text-input.h
@@ -77,15 +77,6 @@ Monitor *output_from_wlr_output(struct wlr_output *wlr_output) {
 	return NULL;
 }
 
-Monitor *output_nearest_to(int32_t lx, int32_t ly) {
-	double closest_x, closest_y;
-	wlr_output_layout_closest_point(output_layout, NULL, lx, ly, &closest_x,
-									&closest_y);
-
-	return output_from_wlr_output(
-		wlr_output_layout_output_at(output_layout, closest_x, closest_y));
-}
-
 bool output_is_usable(Monitor *m) { return m && m->wlr_output->enabled; }
 
 static bool
@@ -255,7 +246,7 @@ static void update_popup_position(struct dwl_input_method_popup *popup) {
 		cursor_rect = (struct wlr_box){0};
 	}
 
-	output = output_nearest_to(cursor_rect.x, cursor_rect.y);
+	output = get_monitor_nearest_to(cursor_rect.x, cursor_rect.y);
 	if (!output_is_usable(output)) {
 		return;
 	}
@@ -301,9 +292,8 @@ static void handle_input_method_commit(struct wl_listener *listener,
 									   void *data) {
 	struct dwl_input_method_relay *relay =
 		wl_container_of(listener, relay, input_method_commit);
-	struct wlr_input_method_v2 *input_method = data;
 	struct text_input *text_input;
-	assert(relay->input_method == input_method);
+	struct wlr_input_method_v2 *input_method = relay->input_method;
 
 	text_input = relay->active_text_input;
 	if (!text_input) {
@@ -333,7 +323,8 @@ static void handle_keyboard_grab_destroy(struct wl_listener *listener,
 										 void *data) {
 	struct dwl_input_method_relay *relay =
 		wl_container_of(listener, relay, keyboard_grab_destroy);
-	struct wlr_input_method_keyboard_grab_v2 *keyboard_grab = data;
+	struct wlr_input_method_keyboard_grab_v2 *keyboard_grab =
+		relay->input_method->keyboard_grab;
 	wl_list_remove(&relay->keyboard_grab_destroy.link);
 
 	if (keyboard_grab->keyboard) {
@@ -365,7 +356,6 @@ static void handle_input_method_destroy(struct wl_listener *listener,
 										void *data) {
 	struct dwl_input_method_relay *relay =
 		wl_container_of(listener, relay, input_method_destroy);
-	assert(relay->input_method == data);
 	wl_list_remove(&relay->input_method_commit.link);
 	wl_list_remove(&relay->input_method_grab_keyboard.link);
 	wl_list_remove(&relay->input_method_new_popup_surface.link);
@@ -571,11 +561,11 @@ struct dwl_input_method_relay *dwl_im_relay_create() {
 	relay->popup_tree = wlr_scene_tree_create(&scene->tree);
 
 	relay->new_text_input.notify = handle_new_text_input;
-	wl_signal_add(&text_input_manager->events.text_input,
+	wl_signal_add(&text_input_manager->events.new_text_input,
 				  &relay->new_text_input);
 
 	relay->new_input_method.notify = handle_new_input_method;
-	wl_signal_add(&input_method_manager->events.input_method,
+	wl_signal_add(&input_method_manager->events.new_input_method,
 				  &relay->new_input_method);
 
 	relay->focused_surface_destroy.notify = handle_focused_surface_destroy;
diff --git a/src/fetch/monitor.h b/src/fetch/monitor.h
index 7a1ca4dc6..041a170b7 100644
--- a/src/fetch/monitor.h
+++ b/src/fetch/monitor.h
@@ -96,3 +96,12 @@ Monitor *xytomon(double x, double y) {
 	struct wlr_output *o = wlr_output_layout_output_at(output_layout, x, y);
 	return o ? o->data : NULL;
 }
+
+Monitor *get_monitor_nearest_to(int32_t lx, int32_t ly) {
+	double closest_x, closest_y;
+	wlr_output_layout_closest_point(output_layout, NULL, lx, ly, &closest_x,
+									&closest_y);
+
+	return output_from_wlr_output(
+		wlr_output_layout_output_at(output_layout, closest_x, closest_y));
+}
diff --git a/src/mango.c b/src/mango.c
index c96c2357b..37a856daa 100644
--- a/src/mango.c
+++ b/src/mango.c
@@ -40,8 +40,10 @@
 #include <wlr/types/wlr_drm_lease_v1.h>
 #include <wlr/types/wlr_export_dmabuf_v1.h>
 #include <wlr/types/wlr_ext_data_control_v1.h>
+#include <wlr/types/wlr_ext_foreign_toplevel_list_v1.h>
 #include <wlr/types/wlr_ext_image_capture_source_v1.h>
 #include <wlr/types/wlr_ext_image_copy_capture_v1.h>
+#include <wlr/types/wlr_fixes.h>
 #include <wlr/types/wlr_fractional_scale_v1.h>
 #include <wlr/types/wlr_gamma_control_v1.h>
 #include <wlr/types/wlr_idle_inhibit_v1.h>
@@ -316,6 +318,10 @@ struct Client {
 	struct wlr_scene_shadow *shadow;
 	struct wlr_scene_blur *blur;
 	struct wlr_scene_tree *scene_surface;
+	struct wlr_scene_tree *image_capture_tree;
+	struct wlr_scene *image_capture_scene;
+	struct wlr_ext_image_capture_source_v1 *image_capture_source;
+	struct wlr_scene_surface *image_capture_scene_surface;
 	struct wl_list link;
 	struct wl_list flink;
 	struct wl_list fadeout_link;
@@ -407,6 +413,7 @@ struct Client {
 	float unfocused_opacity;
 	char oldmonname[128];
 	int32_t noblur;
+	struct wlr_ext_foreign_toplevel_handle_v1 *ext_foreign_toplevel;
 	double master_mfact_per, master_inner_per, stack_inner_per;
 	double old_master_mfact_per, old_master_inner_per, old_stack_inner_per;
 	double old_scroller_pproportion;
@@ -683,6 +690,7 @@ static void virtualkeyboard(struct wl_listener *listener, void *data);
 static void virtualpointer(struct wl_listener *listener, void *data);
 static void warp_cursor(const Client *c);
 static Monitor *xytomon(double x, double y);
+static Monitor *get_monitor_nearest_to(int32_t x, int32_t y);
 static void xytonode(double x, double y, struct wlr_surface **psurface,
 					 Client **pc, LayerSurface **pl, double *nx, double *ny);
 static void clear_fullscreen_flag(Client *c);
@@ -845,7 +853,13 @@ static struct wl_list keyboard_shortcut_inhibitors;
 static uint32_t cursor_mode;
 static Client *grabc;
 static int32_t rzcorner;
-static int32_t grabcx, grabcy;						   /* client-relative */
+static int32_t grabcx, grabcy; /* client-relative */
+
+static struct wlr_ext_foreign_toplevel_image_capture_source_manager_v1
+	*ext_foreign_toplevel_image_capture_source_manager_v1;
+static struct wl_listener new_foreign_toplevel_capture_request;
+static struct wlr_ext_foreign_toplevel_list_v1 *foreign_toplevel_list;
+
 static int32_t drag_begin_cursorx, drag_begin_cursory; /* client-relative */
 static bool start_drag_window = false;
 static int32_t last_apply_drap_time = 0;
@@ -2147,6 +2161,7 @@ void cleanuplisteners(void) {
 	wl_list_remove(&request_start_drag.link);
 	wl_list_remove(&start_drag.link);
 	wl_list_remove(&new_session_lock.link);
+	wl_list_remove(&new_foreign_toplevel_capture_request.link);
 	wl_list_remove(&tearing_new_object.link);
 	wl_list_remove(&keyboard_shortcuts_inhibit_new_inhibitor.link);
 	if (drm_lease_manager) {
@@ -3933,6 +3948,18 @@ mapnotify(struct wl_listener *listener, void *data) {
 	c->geom.width += 2 * c->bw;
 	c->geom.height += 2 * c->bw;
 
+	struct wlr_ext_foreign_toplevel_handle_v1_state foreign_toplevel_state = {
+		.app_id = client_get_appid(c),
+		.title = client_get_title(c),
+	};
+
+	c->image_capture_scene = wlr_scene_create();
+	c->ext_foreign_toplevel = wlr_ext_foreign_toplevel_handle_v1_create(
+		foreign_toplevel_list, &foreign_toplevel_state);
+	c->ext_foreign_toplevel->data = c;
+	c->image_capture_scene_surface = wlr_scene_surface_create(
+		&c->image_capture_scene->tree, client_surface(c));
+
 	/* Handle unmanaged clients first so we can return prior create borders
 	 */
 	if (client_is_unmanaged(c)) {
@@ -4279,6 +4306,26 @@ void outputmgrapply(struct wl_listener *listener, void *data) {
 	outputmgrapplyortest(config, 0);
 }
 
+static void
+handle_new_foreign_toplevel_capture_request(struct wl_listener *listener,
+											void *data) {
+	struct wlr_ext_foreign_toplevel_image_capture_source_manager_v1_request
+		*request = data;
+	Client *c = request->toplevel_handle->data;
+
+	if (c->image_capture_source == NULL) {
+		c->image_capture_source =
+			wlr_ext_image_capture_source_v1_create_with_scene_node(
+				&c->image_capture_scene->tree.node, event_loop, alloc, drw);
+		if (c->image_capture_source == NULL) {
+			return;
+		}
+	}
+
+	wlr_ext_foreign_toplevel_image_capture_source_manager_v1_request_accept(
+		request, c->image_capture_source);
+}
+
 void // 0.7 custom
 outputmgrapplyortest(struct wlr_output_configuration_v1 *config, int32_t test) {
 	/*
@@ -5285,6 +5332,7 @@ void setup(void) {
 	wlr_subcompositor_create(dpy);
 	wlr_alpha_modifier_v1_create(dpy);
 	wlr_ext_data_control_manager_v1_create(dpy, 1);
+	wlr_fixes_create(dpy, 1);
 
 	// 在 setup 函数中
 	wl_signal_init(&mango_print_status);
@@ -5300,6 +5348,15 @@ void setup(void) {
 	power_mgr = wlr_output_power_manager_v1_create(dpy);
 	wl_signal_add(&power_mgr->events.set_mode, &output_power_mgr_set_mode);
 
+	foreign_toplevel_list = wlr_ext_foreign_toplevel_list_v1_create(dpy, 1);
+	ext_foreign_toplevel_image_capture_source_manager_v1 =
+		wlr_ext_foreign_toplevel_image_capture_source_manager_v1_create(dpy, 1);
+	new_foreign_toplevel_capture_request.notify =
+		handle_new_foreign_toplevel_capture_request;
+	wl_signal_add(&ext_foreign_toplevel_image_capture_source_manager_v1->events
+					   .new_request,
+				  &new_foreign_toplevel_capture_request);
+
 	tearing_control = wlr_tearing_control_manager_v1_create(dpy, 1);
 	tearing_new_object.notify = handle_tearing_new_object;
 	wl_signal_add(&tearing_control->events.new_object, &tearing_new_object);
@@ -5678,6 +5735,11 @@ void unmapnotify(struct wl_listener *listener, void *data) {
 		(!c->mon || VISIBLEON(c, c->mon)))
 		init_fadeout_client(c);
 
+	if (c->ext_foreign_toplevel) {
+		wlr_ext_foreign_toplevel_handle_v1_destroy(c->ext_foreign_toplevel);
+		c->ext_foreign_toplevel = NULL;
+	}
+
 	// If the client is in a stack, remove it from the stack
 
 	if (c->swallowedby) {
@@ -5762,6 +5824,8 @@ void unmapnotify(struct wl_listener *listener, void *data) {
 	c->next_in_stack = NULL;
 	c->prev_in_stack = NULL;
 
+	wlr_scene_node_destroy(&c->image_capture_scene_surface->buffer->node);
+	wlr_scene_node_destroy(&c->image_capture_scene->tree.node);
 	wlr_scene_node_destroy(&c->scene->node);
 	printstatus();
 	motionnotify(0, NULL, 0, 0, 0, 0);
@@ -5911,6 +5975,14 @@ void updatetitle(struct wl_listener *listener, void *data) {
 	title = client_get_title(c);
 	if (title && c->foreign_toplevel)
 		wlr_foreign_toplevel_handle_v1_set_title(c->foreign_toplevel, title);
+	if (title && c->ext_foreign_toplevel) {
+		wlr_ext_foreign_toplevel_handle_v1_update_state(
+			c->ext_foreign_toplevel,
+			&(struct wlr_ext_foreign_toplevel_handle_v1_state){
+				.title = title,
+				.app_id = c->ext_foreign_toplevel->app_id,
+			});
+	}
 	if (c == focustop(c->mon))
 		printstatus();
 }
@@ -6244,11 +6316,13 @@ void xwaylandready(struct wl_listener *listener, void *data) {
 	wlr_xwayland_set_seat(xwayland, seat);
 
 	/* Set the default XWayland cursor to match the rest of dwl. */
-	if ((xcursor = wlr_xcursor_manager_get_xcursor(cursor_mgr, "default", 1)))
-		wlr_xwayland_set_cursor(
-			xwayland, xcursor->images[0]->buffer, xcursor->images[0]->width * 4,
-			xcursor->images[0]->width, xcursor->images[0]->height,
-			xcursor->images[0]->hotspot_x, xcursor->images[0]->hotspot_y);
+	if ((xcursor = wlr_xcursor_manager_get_xcursor(cursor_mgr, "default", 1))) {
+		struct wlr_xcursor_image *image = xcursor->images[0];
+		struct wlr_buffer *buffer = wlr_xcursor_image_get_buffer(image);
+		wlr_xwayland_set_cursor(xwayland, buffer, xcursor->images[0]->hotspot_x,
+								xcursor->images[0]->hotspot_y);
+	}
+
 	/* xwayland can't auto sync the keymap, so we do it manually
 	  and we need to wait the xwayland completely inited
 	*/

